local AddOn, NS = ...

local find = string.find

local function Update_All_NewSettings()
	--TigerHeart
	if (not DUF_Settings[DUF_INDEX].focus) then
		DUF_Settings[DUF_INDEX].focus = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget, DUF_Settings[DUF_INDEX].focus)
		DUF_Settings[DUF_INDEX].focus.hide = true
		DUF_Settings[DUF_INDEX].focus.ComboPoints = nil
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.0"]) then
		DUF_Settings[DUF_INDEX].target.ComboPoints.xoffset = DUF_Settings[DUF_INDEX].ComboOffset.x
		DUF_Settings[DUF_INDEX].target.ComboPoints.yoffset = DUF_Settings[DUF_INDEX].ComboOffset.y
		DUF_Settings[DUF_INDEX].ComboOffset.y = nil
		DUF_Settings[DUF_INDEX].ComboOffset.x = nil
		DUF_Settings[DUF_INDEX].optionscale = 1
		DUF_Settings[DUF_INDEX].updatespeed = 1 / 30
		DUF_Settings[DUF_INDEX].updatespeedbase = 30
		DUF_Settings[DUF_INDEX].flashthreshold = .1
		DUF_Settings[DUF_INDEX].healththreshold1 = .6
		DUF_Settings[DUF_INDEX].healththreshold2 = .3
		DUF_Settings[DUF_INDEX].healthcolor1 = { r=1, g=1, b=0 }
		DUF_Settings[DUF_INDEX].healthcolor2 = { r=1, g=0, b=0 }
		DUF_Settings[DUF_INDEX].manathreshold1 = .6
		DUF_Settings[DUF_INDEX].manathreshold2 = .3
		DUF_Settings[DUF_INDEX].manacolor1 = { r=1, g=1, b=0 }
		DUF_Settings[DUF_INDEX].manacolor2 = { r=1, g=0, b=0 }
		DUF_Settings[DUF_INDEX].targettarget = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target, DUF_Settings[DUF_INDEX].targettarget)
		DUF_Settings[DUF_INDEX].targettarget.hide = true
		DUF_Settings[DUF_INDEX].targettarget.ComboPoints = nil

		--TigerHeart
		DUF_Settings[DUF_INDEX].focus = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget, DUF_Settings[DUF_INDEX].focus)
		DUF_Settings[DUF_INDEX].focus.hide = true
		DUF_Settings[DUF_INDEX].focus.ComboPoints = nil

		DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.XP] = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.XP], DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.XP])
		DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.XP].hide = true
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].RaceIcon = {}
				DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].ClassIcon, DUF_Settings[DUF_INDEX][unit].RaceIcon)
				DUF_Settings[DUF_INDEX][unit].RaceIcon.hide = true
				DUF_Settings[DUF_INDEX][unit].backgroundstyle = 2
				DUF_Settings[DUF_INDEX][unit].bgalpha = 1
				DUF_Settings[DUF_INDEX][unit].bgcolor.a = nil
				DUF_Settings[DUF_INDEX][unit].bordercolor.a = nil
				DUF_Settings[DUF_INDEX][unit].bgpadding = 5
				DUF_Settings[DUF_INDEX][unit].Buffs.spacing = 0
				DUF_Settings[DUF_INDEX][unit].Debuffs.spacing = 0
				DUF_Settings[DUF_INDEX][unit].Buffs.bordercolor = { r=1, g=1, b=1 }
				DUF_Settings[DUF_INDEX][unit].Debuffs.bordercolor = { r=1, g=1, b=1 }
				if (DUF_Settings[DUF_INDEX][unit].context == "Reaction") then
					DUF_Settings[DUF_INDEX][unit].context = 2
				elseif (DUF_Settings[DUF_INDEX][unit].context == "Difficulty") then
					DUF_Settings[DUF_INDEX][unit].context = 1
				elseif (DUF_Settings[DUF_INDEX][unit].context == "Class") then
					DUF_Settings[DUF_INDEX][unit].context = 3
				else
					DUF_Settings[DUF_INDEX][unit].context = nil
				end
				if (DUF_Settings[DUF_INDEX][unit].recolor) then
					DUF_Settings[DUF_INDEX][unit].bgcontext = 4
				end
				DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.TargetHealth] = {}
				DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.TargetPower] = {}
				DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.Health], DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.TargetHealth])
				DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.Power], DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.TargetPower])
				DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.TargetHealth].hide = true
				DUF_Settings[DUF_INDEX][unit].StatusBar[NS.Bar.TargetPower].hide = true
				DUF_Settings[DUF_INDEX][unit].leftclick = 1
				DUF_Settings[DUF_INDEX][unit].rightclick = 3
				DUF_Settings[DUF_INDEX][unit].middleclick = 2
				DUF_Settings[DUF_INDEX][unit].connectmethod = 1
				DUF_Settings[DUF_INDEX][unit].spacing = 0
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "TextBox") then
						for i=1,10 do
							DUF_Settings[DUF_INDEX][unit][element][i].backgroundstyle = 1
							DUF_Settings[DUF_INDEX][unit][element][i].bgalpha = 1
							if (not DUF_Settings[DUF_INDEX][unit][element][i].borderalpha) then
								DUF_Settings[DUF_INDEX][unit][element][i].borderalpha = 1
							end
							DUF_Settings[DUF_INDEX][unit][element][i].bgcolor.a = nil
							DUF_Settings[DUF_INDEX][unit][element][i].bordercolor.a = nil
							DUF_Settings[DUF_INDEX][unit][element][i].bgpadding = 1
							DUF_Settings[DUF_INDEX][unit][element][i].font = 1
							DUF_Settings[DUF_INDEX][unit][element][i].justifyV = "CENTER"
							if (not DUF_Settings[DUF_INDEX][unit][element][i].showbg) then
								DUF_Settings[DUF_INDEX][unit][element][i].hidebg = true
							end
							DUF_Settings[DUF_INDEX][unit][element][i].showbg = nil
							if (DUF_Settings[DUF_INDEX][unit][element][i].context == "Reaction") then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 2
							elseif (DUF_Settings[DUF_INDEX][unit][element][i].context == "Difficulty") then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 1
							elseif (DUF_Settings[DUF_INDEX][unit][element][i].context == "Class") then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 3
							else
								DUF_Settings[DUF_INDEX][unit].context = nil
							end
							if (not DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor) then
								DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor = { r=1, g=1, b=0 }
							end
							DUF_Settings[DUF_INDEX][unit][element][i].attach = "Unit Frame"
							DUF_Settings[DUF_INDEX][unit][element][i].attachpoint = "TOPLEFT"
							DUF_Settings[DUF_INDEX][unit][element][i].attachto = "TOPLEFT"
							DUF_Settings[DUF_INDEX][unit][element][i].leftclick = 1
							DUF_Settings[DUF_INDEX][unit][element][i].rightclick = 3
							DUF_Settings[DUF_INDEX][unit][element][i].middleclick = 2
						end
					elseif (element == "StatusBar") then
						for i=1,6 do
							if (DUF_Settings[DUF_INDEX][unit][element][i]) then
								DUF_Settings[DUF_INDEX][unit][element][i].backgroundstyle = 1
								DUF_Settings[DUF_INDEX][unit][element][i].bgalpha = 1
								DUF_Settings[DUF_INDEX][unit][element][i].bgcolor.a = nil
								DUF_Settings[DUF_INDEX][unit][element][i].bordercolor.a = nil
								DUF_Settings[DUF_INDEX][unit][element][i].bgpadding = 1
								DUF_Settings[DUF_INDEX][unit][element][i].color2 = {r=1, g=1, b=0}
								DUF_Settings[DUF_INDEX][unit][element][i].attach = "Unit Frame"
								DUF_Settings[DUF_INDEX][unit][element][i].attachpoint = "TOPLEFT"
								DUF_Settings[DUF_INDEX][unit][element][i].attachto = "TOPLEFT"
								DUF_Settings[DUF_INDEX][unit][element][i].leftclick = 1
								DUF_Settings[DUF_INDEX][unit][element][i].rightclick = 3
								DUF_Settings[DUF_INDEX][unit][element][i].middleclick = 2
								if (not DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor) then
									DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor = { r=1, g=1, b=0 }
								end
								if (DUF_Settings[DUF_INDEX][unit][element][i].recolor) then
									if (i==1) then
										DUF_Settings[DUF_INDEX][unit][element][i].context = 4
									else
										DUF_Settings[DUF_INDEX][unit][element][i].context = 5
									end
									DUF_Settings[DUF_INDEX][unit][element][i].recolor = nil
								end
							end
							if (i == 1 or i == 4) then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 4
							elseif (i == 2 or i == 5) then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 5
								DUF_Settings[DUF_INDEX][unit][element][i].hideifnomana = true
							end
						end
					else
						DUF_Settings[DUF_INDEX][unit][element].backgroundstyle = 2
						DUF_Settings[DUF_INDEX][unit][element].bgalpha = 1
						DUF_Settings[DUF_INDEX][unit][element].bgcolor.a = nil
						DUF_Settings[DUF_INDEX][unit][element].bgpadding = 5
						DUF_Settings[DUF_INDEX][unit][element].context = nil
						if (not DUF_Settings[DUF_INDEX][unit][element].mouseovercolor) then
							DUF_Settings[DUF_INDEX][unit][element].mouseovercolor = { r=1, g=1, b=0 }
						end
						DUF_Settings[DUF_INDEX][unit][element].attach = "Unit Frame"
						DUF_Settings[DUF_INDEX][unit][element].attachpoint = "TOPLEFT"
						DUF_Settings[DUF_INDEX][unit][element].attachto = "TOPLEFT"
						DUF_Settings[DUF_INDEX][unit][element].leftclick = 1
						DUF_Settings[DUF_INDEX][unit][element].rightclick = 3
						DUF_Settings[DUF_INDEX][unit][element].middleclick = 2
						if (not DUF_Settings[DUF_INDEX][unit][element].borderalpha) then
							DUF_Settings[DUF_INDEX][unit][element].borderalpha = 1
						end
					end
				end
			end
		end
		DUF_Settings[DUF_INDEX].target.ComboPoints.backgroundstyle = 2
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgalpha = 1
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgcolor.a = nil
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgpadding = 5
		DUF_Settings[DUF_INDEX].target.ComboPoints.attach = "Unit Frame"
		DUF_Settings[DUF_INDEX].target.ComboPoints.attachpoint = "TOPLEFT"
		DUF_Settings[DUF_INDEX].target.ComboPoints.attachto = "TOPLEFT"
		DUF_Settings[DUF_INDEX].target.ComboPoints.mouseovercolor = { r=1, g=1, b=0 }
		DUF_Settings[DUF_INDEX].target.EliteTexture = { size=128, alpha=1, bgcolor={ r=0, g=0, b=0}, bordercolor={ r=0, gt=0, b=0}, mouseovercolor={ r=1, g=1, b=0}, bgalpha=1, bgpadding=5, hidebg=true, backgroundstyle=2, borderalpha=1, xoffset=0, yoffset=0, attach="Unit Frame", attachto="TOPLEFT", attachpoint="TOPLEFT", hide=true}
	end
	DUF_Settings[DUF_INDEX].ComboOffset = nil

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.0f"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for i=1,10 do
					if (tonumber(DUF_Settings[DUF_INDEX][unit].TextBox[i].font)) then
						DUF_Settings[DUF_INDEX][unit].TextBox[i].font = "DUF_Font"..DUF_Settings[DUF_INDEX][unit].TextBox[i].font..".ttf"
					end
				end
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.1"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].Portrait.bordcolor = { r=1, g=1, b=1 }
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "TextBox") then
						for i=1,10 do
							DUF_Settings[DUF_INDEX][unit][element][i].framelevel = 0
							DUF_Settings[DUF_INDEX][unit][element][i].framestrata = "LOW"
							DUF_Settings[DUF_INDEX][unit][element][i].label = DUF_TEXT["TextBox"..i]
						end
					elseif (element == "StatusBar") then
						for i=1,6 do
							if (DUF_Settings[DUF_INDEX][unit][element][i]) then
								DUF_Settings[DUF_INDEX][unit][element][i].framelevel = 0
								DUF_Settings[DUF_INDEX][unit][element][i].framestrata = "BACKGROUND"
							end
						end
					else
						if (DUF_Settings[DUF_INDEX][unit][element] == nil) then
							DUF_Settings[DUF_INDEX][unit][element] = { }
						end
						DUF_Settings[DUF_INDEX][unit][element].framelevel = 0
						DUF_Settings[DUF_INDEX][unit][element].framestrata = "LOW"
					end
				end
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.2"]) then
		DUF_Settings[DUF_INDEX].player.Buffs.durationheight = 6
		DUF_Settings[DUF_INDEX].player.Buffs.durationcolor = { r=1, g=1, b=1 }
		DUF_Settings[DUF_INDEX].player.Buffs.durationfont = "DUF_Font1.ttf"
		DUF_Settings[DUF_INDEX].player.Buffs.durationalpha = 1
		DUF_Settings[DUF_INDEX].player.Buffs.durationx = 0
		DUF_Settings[DUF_INDEX].player.Buffs.durationy = -5
		DUF_Settings[DUF_INDEX].player.Debuffs.durationheight = 6
		DUF_Settings[DUF_INDEX].player.Debuffs.durationcolor = { r=1, g=1, b=1 }
		DUF_Settings[DUF_INDEX].player.Debuffs.durationfont = "DUF_Font1.ttf"
		DUF_Settings[DUF_INDEX].player.Debuffs.durationalpha = 1
		DUF_Settings[DUF_INDEX].player.Debuffs.durationx = 0
		DUF_Settings[DUF_INDEX].player.Debuffs.durationy = -5
		for i=0,3 do
			DUF_Settings[DUF_INDEX]["usefor"..i] = 1
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.2c"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].Buffs.hspacing = DUF_Settings[DUF_INDEX][unit].Buffs.spacing
				DUF_Settings[DUF_INDEX][unit].Buffs.vspacing = DUF_Settings[DUF_INDEX][unit].Buffs.spacing
				DUF_Settings[DUF_INDEX][unit].Debuffs.hspacing = DUF_Settings[DUF_INDEX][unit].Debuffs.spacing
				DUF_Settings[DUF_INDEX][unit].Debuffs.vspacing = DUF_Settings[DUF_INDEX][unit].Debuffs.spacing
			end
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3s"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for i=1,6 do
					if (DUF_Settings[DUF_INDEX][unit].StatusBar[i]) then
						DUF_Settings[DUF_INDEX][unit].StatusBar[i].direction = 1
					end
				end
			end
		end
	end
	--Eris
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3x"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "Buffs" or element == "Debuffs") then
						DUF_Settings[DUF_INDEX][unit][element].showduration = 1
						DUF_Settings[DUF_INDEX][unit][element].altformat = 1
						DUF_Settings[DUF_INDEX][unit][element].durationx = 0
						DUF_Settings[DUF_INDEX][unit][element].durationy = -5
						DUF_Settings[DUF_INDEX][unit][element].durationheight = 6
						DUF_Settings[DUF_INDEX][unit][element].durationalpha = 1
						DUF_Settings[DUF_INDEX][unit][element].durationfont = "DUF_Font1.ttf"
						DUF_Settings[DUF_INDEX][unit][element].durationcolor = { r=1, g=1, b=1 }
					end
				end
			end
		end
		DUF_Settings[DUF_INDEX]["classcolorShaman"] = {
				["r"] = .14,
				["g"] = .35,
				["b"] = 1,
			}
	end
	
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.4"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do			
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].VoiceIcon = {
					["bgcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["borderalpha"] = 0,
					["framestrata"] = "LOW",
					["attachpoint"] = "TOPLEFT",
					["framelevel"] = 0,
					["middleclick"] = 2,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["size"] = 20,
					["bgpadding"] = 5,
					["attach"] = "Unit Frame",
					["bordercolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["alpha"] = 1,
					["yoffset"] = 0,
					["hide"] = false,
					["backgroundstyle"] = 2,
					["xoffset"] = 0,
					["bgalpha"] = 1,
					["rightclick"] = 3,
					["leftclick"] = 1,
					["bgtexture"] = "VoiceChat-Speaker.tga",
				}
			end
		end
	end

-- scree, 3.0.3a, Dec 2008
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED3.0.3a"]) then
		DUF_Settings[DUF_INDEX]["classcolorDeathKnight"] = {
				["r"] = 0.77,
				["g"] = 0.12,
				["b"] = 0.23,
			}
	end
	
-- scree, 3.1.0a, Mar 2009
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED3.1.0a"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				local statusBarHasMana = { 2, 5 }
				for _,v in ipairs(statusBarHasMana) do
					if unit ~= "boss" then
						DUF_Settings[DUF_INDEX][unit].StatusBar[v]["runicpowercolor"] = {
							["r"] = 0.00,
							["g"] = 0.82,
							["b"] = 1.00,
						}
					end
				end
			end
		end
	end

--Fizzlemizz: Comment: 4.0 initalisation settings for TempEnchants
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0"]) then
		DUF_Settings[DUF_INDEX]["player"].TempEnchants = {
			["bgcolor"] = {
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["borderalpha"] = 1,
			["rightclick"] = 3,
			["altformat"] = 1,
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["middleclick"] = 2,
			["vertical"] = false,
			["spacing"] = 3,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["vspacing"] = 0,
			["hspacing"] = -10,
			["hidebg"] = 1,
			["shown"] = 2,
			["bgpadding"] = 5,
			["background"] = false,
			["framestrata"] = "LOW",
			["leftclick"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["mouseover"] = false,
			["attachto"] = "TOPRIGHT",
			["attachpoint"] = "TOPRIGHT",
			["backgroundstyle"] = 2,
			["alpha"] = 1,
			["xoffset"] = -167,
			["size"] = 32,
			["yoffset"] = 27,
			["durationheight"] = 6,
			["durationheight"] = 6,
			["durationcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["durationfont"] = "DUF_Font1.ttf",
			["durationalpha"] = 1,
			["durationx"] = 0,
			["durationy"] = -5,
		}
	end

--Fizzlemizz: Comment: 4.1a initalisation settings for duration timer performance update
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0b"]) then
		DUF_Settings[DUF_INDEX].limitdurationupdates = nil
	end

--Fizzlemizz: Comment: 4.15 initalisation settings for Temp. Enchant MouseOver error
	if (DUF_Settings[DUF_INDEX]["player"].TempEnchants.usemouseovercolor == nil) then
		DUF_Settings[DUF_INDEX]["player"]["TempEnchants"].usemouseovercolor = 0
	end
	
--Fizzlemizz: Comment: 4.17 Setting for 3D models
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.17"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit]["Portrait"].use3D = false
				DUF_Settings[DUF_INDEX][unit]["Portrait"].use3Dface = false
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.18"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit]["RoleIcon"] = {
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["borderalpha"] = 1,
					["rightclick"] = 3,
					["attachpoint"] = "CENTER",
					["middleclick"] = 2,
					["attachto"] = "BOTTOMRIGHT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["hide"] = 1,
					["bgpadding"] = 3,
					["attach"] = "_Portrait",
					["bordercolor"] = {
						["r"] = 0.996078,
						["g"] = 1,
						["b"] = 0,
					},
					["alpha"] = 1,
					["leftclick"] = 1,
					["size"] = 25,
					["backgroundstyle"] = 2,
					["xoffset"] = 4,
					["bgalpha"] = 1,
					["hidebg"] = 1,
					["yoffset"] = -4,
				}
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0"]) then
		DUF_Settings[DUF_INDEX]["classcolorMonk"] = {
			["r"] = 0,
			["g"] = 1,
			["b"] = .588,
		}
	end	

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0a"]) then
		DUF_Settings[DUF_INDEX].player["MonkHarmony"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["hidebg"] = 1,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["disablemouse"] = 1,
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["framestrata"] = "BACKGROUND",
			["backgroundstyle"] = 2,
			["yoffset"] = 5,
		}
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0b"]) then
		DUF_Settings[DUF_INDEX].player.MonkHarmony["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			}

		DUF_Settings[DUF_INDEX].player["PalyPowerFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["size"] = 20,
			["bgpadding"] = 5,
			["hidebg"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 10,
		}
		DUF_Settings[DUF_INDEX].player["WarlockPowerFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["hidebg"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 17,
		}
		DUF_Settings[DUF_INDEX].player["RuneFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["bgHeight"] = 16,
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["hidebg"] = 1,
			["framelevel"] = 0,
			["spacing"] = 10,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = -51,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 5,
		}
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0c"]) then
		DUF_Settings[DUF_INDEX].player.WarlockPowerFrame.DemoBar = nil
		DUF_Settings[DUF_INDEX]["player"]["TextBox"][11] = {
			["outline"] = "NORMAL",
			["leftclick"] = 1,
			["bgcolor"] = {
				["b"] = 0.09019607843137255,
				["g"] = 0.01176470588235294,
				["r"] = 0.08627450980392157,
			},
			["borderalpha"] = 0,
			["framestrata"] = "LOW",
			["attachpoint"] = "LEFT",
			["justifyV"] = "TOP",
			["verttext"] = 1,
			["textheight"] = 9,
			["middleclick"] = 2,
			["bgalpha"] = 0.57,
			["attachto"] = "RIGHT",
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["height"] = 50,
			["hidebg"] = 1,
			["bgpadding"] = 7,
			["textcolor"] = {
				["r"] = 0.984313725490196,
				["g"] = 0.996078431372549,
				["b"] = 1,
			},
			["justify"] = "LEFT",
			["alpha"] = 1,
			["attach"] = "_HealthBar",
			["text"] = "$rp%",
			["backgroundstyle"] = 2,
			["width"] = 14,
			["rightclick"] = 3,
			["font"] = "DUF_Font3.ttf",
			["bordercolor"] = {
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgtexture"] = "",
			["xoffset"] = 0,
			["framelevel"] = 1,
			["yoffset"] = 0,
		} -- [11] Druid mana Bar Text
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.2"]) then
		if not DUF_Settings[DUF_INDEX].boss then
			DUF_Settings[DUF_INDEX].boss = {}
			DL_COPY_Table(DUF_Settings[DUF_INDEX].party, DUF_Settings[DUF_INDEX].boss)
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.4"]) then -- 5.4 Missed Castbar settings for Pet statusbar update
		if DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.AltMana] and not DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.Cast] then
			DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.Cast] = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.AltMana], DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.Cast])
			DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.AltMana] = nil
			DUF_Settings[DUF_INDEX].party.StatusBar[NS.Bar.AltMana] = nil
			DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.Cast] = nil
			DUF_Settings[DUF_INDEX].target.StatusBar[NS.Bar.AltMana] = nil
			DUF_Settings[DUF_INDEX].targettarget.StatusBar[NS.Bar.AltMana] = nil
			DUF_Settings[DUF_INDEX].focus.StatusBar[NS.Bar.AltMana] = nil
			DUF_Settings[DUF_INDEX].boss.StatusBar[NS.Bar.AltMana] = nil
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.6"]) then -- 5.6 Missed settings for PartyPet castbar update
		if (DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.AltMana] and not DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.Cast]) then
			DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.Cast] = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.AltMana], DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.Cast])
			DUF_Settings[DUF_INDEX].partypet.StatusBar[NS.Bar.AltMana] = nil
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.7"]) then -- 5.7 Fixed setting for Warlock Demo bar
		if not DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].color then
			if DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].manacolor then
				DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].color= {}
				DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].manacolor, DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].color)
			else
				DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].color = {
					["r"] = 0.4980392156862745,
					["g"] = 0,
					["b"] = 0.592156862745098,
				}
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.10"]) then -- 5.10 Adding Default Attach point Maybe being able to hide buff stacks
		DUF_Settings[DUF_INDEX].player.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].player.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].pet.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].pet.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].target.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].target.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].targettarget.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].targettarget.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].focus.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].focus.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].party.attachpoint = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].party.attachto = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].partypet.attachpoint = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].partypet.attachto = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].boss.attachpoint = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].boss.attachto = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.11"]) then -- Adding target markers.
		DUF_Settings[DUF_INDEX].target.Markers = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.ClassIcon, DUF_Settings[DUF_INDEX].target.Markers) -- copt setting from class icon
		DUF_Settings[DUF_INDEX].target.Markers.width = DUF_Settings[DUF_INDEX].target.Markers.size
		DUF_Settings[DUF_INDEX].target.Markers.height = DUF_Settings[DUF_INDEX].target.Markers.size
		DUF_Settings[DUF_INDEX].target.Markers.markersize = DUF_Settings[DUF_INDEX].target.Markers.size
		DUF_Settings[DUF_INDEX].target.Markers.size = nil
		DUF_Settings[DUF_INDEX].target.Markers.xos = {[1]=0, [2]=DUF_Settings[DUF_INDEX].target.ClassIcon.size, [3]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 2, [4]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 3, [5]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 4, [6]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 5, [7]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 6, [8]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 7}
		DUF_Settings[DUF_INDEX].target.Markers.yos = {[1]=0, [2]=0, [3]=0, [4]=0, [5]=0, [6]=0, [7]=0, [8]=0}
		DUF_Settings[DUF_INDEX].target.Markers.icons = {}
		DUF_Settings[DUF_INDEX].target.Markers.icons[1] = {file="interface\\targetingframe\\ui-raidtargetingicons", left=0, right=.25, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[2] = {file="interface\\targetingframe\\ui-raidtargetingicons", left=.25, right=.5, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[3] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.5, right=.75, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[4] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.75, right=1, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[5] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=0, right=.25, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.icons[6] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.25, right=.5, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.icons[7] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.5, right=.75, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.icons[8] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.75, right=1, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.yoffset = DUF_Settings[DUF_INDEX].target.Markers.yoffset - 20 -- and move down 20
	end
	
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED6.0"]) then -- Adding QuestBoss markers.
		DUF_Settings[DUF_INDEX].target.QuestBossIcon = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.RoleIcon, DUF_Settings[DUF_INDEX].target.QuestBossIcon)
		DUF_Settings[DUF_INDEX].target.QuestBossIcon.texture = "Interface\\TargetingFrame\\PortraitQuestBadge"
		for _, unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit].PhaseIcon = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusIcon, DUF_Settings[DUF_INDEX][unit].PhaseIcon)
			DUF_Settings[DUF_INDEX][unit].PhaseIcon.xoffset = DUF_Settings[DUF_INDEX][unit].PhaseIcon.xoffset + DUF_Settings[DUF_INDEX][unit].PhaseIcon.size
			DUF_Settings[DUF_INDEX][unit].PhaseIcon.hide = true
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0"] then -- Adding updated class bar for Legion.
		for _,v in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][v].TempEnchants_1 = nil
			DUF_Settings[DUF_INDEX][v].TempEnchants_2 = nil
		end
	
		for _,v in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].insanitycolor = { r=0.40, g=0, b=0.80, }
			DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].insanitycolor = { r=0.40, g=0, b=0.80, }
			DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
			DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
		end
		DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.AltMana].runicpowercolor = nil
		DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.AltMana].focuscolor = nil
	
	---- ROGUE
		local settings
		DUF_Settings[DUF_INDEX].player.ROGUE = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.ComboPoints, DUF_Settings[DUF_INDEX].player.ROGUE)
		DUF_Settings[DUF_INDEX].player.ComboPoints = nil
		settings = DUF_Settings[DUF_INDEX].player.ROGUE
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		settings.numtextures = 0
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		if settings.customtexture then
			settings.numtextures = 1
			settings.textures[1] = {
				texture = settings.customtexture,
				level = "ARTWORK",
				defaultcolor = true,
				color = settings.color,
			}
		end
		settings.size = nil
		settings.customtexture = nil
	
	---- DRUID
		DUF_Settings[DUF_INDEX].player.DRUID = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.ROGUE, DUF_Settings[DUF_INDEX].player.DRUID)
	
	---- PALADIN
		DUF_Settings[DUF_INDEX].player.PALADIN = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.PalyPowerFrame, DUF_Settings[DUF_INDEX].player.PALADIN)
		DUF_Settings[DUF_INDEX].player.PalyPowerFrame = nil
		settings = DUF_Settings[DUF_INDEX].player.PALADIN
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.numtextures = 0
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
	
		settings.size = nil
		settings.customtexture = nil
	
	---- MONK
		DUF_Settings[DUF_INDEX].player.MONK = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.MonkHarmony, DUF_Settings[DUF_INDEX].player.MONK )
		DUF_Settings[DUF_INDEX].player.MonkHarmony = nil
		settings = DUF_Settings[DUF_INDEX].player.MONK
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.color={ r=1, g=1, b=1 } 
		settings.color2 = settings.color
		settings.numtextures = 0
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		settings.size = nil
		settings.customtexture = nil
	
	-- MONK Stagger
		DUF_Settings[DUF_INDEX].player["MONK"..SPEC_MONK_BREWMASTER] = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.MONK, DUF_Settings[DUF_INDEX].player["MONK"..SPEC_MONK_BREWMASTER])
		settings = DUF_Settings[DUF_INDEX].player["MONK"..SPEC_MONK_BREWMASTER]
		settings.width = DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Power].width
		settings.height = DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Power].height
		if settings.width < 10 then
			settings.width = 10
		end
		if settings.height < 10 then
			settings.height = 10
		end
		settings.sizelock = nil
		settings.numtextures = 1
		settings.backgroundstyle = 2
		settings.hidebg = false
		settings.bgpadding = 5
		settings.borderalpha = 0.65
		settings.color = {
			r = 0.501960784313726,
			g = 0.615686274509804,
			b = 1,
		}
		settings.bordercolor = {
			r = 0.945098039215686,
			g = 0.796078431372549,
			b = 0.584313725490196,
		}
		settings.bgcolor = {
			r = 0.211764705882353,
			g = 0.219607843137255,
			b = 0.470588235294118,
		}
		settings.bgsize = {
			height = 16,
			width = 12,
		}
		settings.textures[1] = {
			texture = "bg0",
			level = "ARTWORK",
		}
	
	---- MAGE
		DUF_Settings[DUF_INDEX].player.MAGE = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.PALADIN, DUF_Settings[DUF_INDEX].player.MAGE)
		DUF_Settings[DUF_INDEX].player.MAGE.width = 30
		DUF_Settings[DUF_INDEX].player.MAGE.height = 30
	
	---- DEATHKNIGHT
		DUF_Settings[DUF_INDEX].player.DEATHKNIGHT = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.RuneFrame, DUF_Settings[DUF_INDEX].player.DEATHKNIGHT)
		DUF_Settings[DUF_INDEX].player.RuneFrame = nil
		settings = DUF_Settings[DUF_INDEX].player.DEATHKNIGHT
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.numtextures = 0
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		settings.size = nil
		settings.customtexture = nil
	
	---- WARLOCK
		DUF_Settings[DUF_INDEX].player.WARLOCK = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.WarlockPowerFrame, DUF_Settings[DUF_INDEX].player.WARLOCK)
		DUF_Settings[DUF_INDEX].player.WarlockPowerFrame = nil
		settings = DUF_Settings[DUF_INDEX].player.WARLOCK
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.numtextures = 0
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		settings.size = nil
		settings.customtexture = nil
	
	---- CLEANUP
		DUF_Settings[DUF_INDEX].player.AnticipationPoints = nil
		DUF_Settings[DUF_INDEX].target.ComboPoints = nil
		DUF_Settings[DUF_INDEX].target.AnticipationPoints = nil
		DUF_Settings[DUF_INDEX].player.PriestOrbFrame = nil
		DUF_Settings[DUF_INDEX].player.EclipseFrame = nil
		DUF_Settings[DUF_INDEX].player.TextBox[12] = nil -- WoD Warlock text
--		DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor] = nil -- WoD Warlock statusbar
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0a"] then
		DUF_Settings[DUF_INDEX].classcolorDemonHunter = {
			["r"] = 0.64,
			["g"] = 0.19,
			["b"] = 0.79,
		}
	end
	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0b"] then
		DUF_Settings[DUF_INDEX].player.TotemFrame = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.MAGE, DUF_Settings[DUF_INDEX].player.TotemFrame)
		DUF_Settings[DUF_INDEX].player.TotemFrame.scale = 1
	end	
	
	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0c"] then -- Adding updated class bar for Legion.
		for k,v in pairs(DUF_FRAME_INDICES) do
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].insanitycolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].insanitycolor = { r=0.40, g=0, b=0.80, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].insanitycolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].insanitycolor = { r=0.40, g=0, b=0.80, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].lunarpowercolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].lunarpowercolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].maelstrompower then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].maelstrompower then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.TargetPower].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
			end
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.2"] then -- Removing Voice Icon as an attach
		local function FrameMoved(unit, frame)
			print("Voice Icon Removed:\n", unit, frame, "now attached to Unit Frame")
		end
		local elementList = {}
		DL_Copy_Table(DUF_ELEMENT_INDICES, elementList)
		tinsert(elementList, "EliteTexture")
		tinsert(elementList, "Markers")
		tinsert(elementList, "XPBar")
		tinsert(elementList, "QuestBossIcon")
		for _,unit in pairs(DUF_FRAME_INDICES) do
			for _, frame in pairs(elementList) do
				if frame ~= "TextBox" and frame ~= "StatusBar" then
					if DUF_Settings[DUF_INDEX][unit][frame] and DUF_Settings[DUF_INDEX][unit][frame].attach and find(DUF_Settings[DUF_INDEX][unit][frame].attach, "_VoiceIcon") then
						FrameMoved(unit, frame)
						DUF_Settings[DUF_INDEX][unit][frame].attach = "Unit Frame"
					end
				end
			end
			for i=1, #DUF_Settings[DUF_INDEX][unit].StatusBar do
				if DUF_Settings[DUF_INDEX][unit].StatusBar[i] and DUF_Settings[DUF_INDEX][unit].StatusBar[i].attach and find(DUF_Settings[DUF_INDEX][unit].StatusBar[i].attach, "_VoiceIcon") then
					FrameMoved(unit, "StatusBar"..i)
					DUF_Settings[DUF_INDEX][unit].StatusBar[i].attach = "Unit Frame"
				end
			end
			for i=1, #DUF_Settings[DUF_INDEX][unit].TextBox do
				if DUF_Settings[DUF_INDEX][unit].TextBox[i] and DUF_Settings[DUF_INDEX][unit].TextBox[i].attach and find(DUF_Settings[DUF_INDEX][unit].TextBox[i].attach, "_VoiceIcon") then
					FrameMoved(unit, "TextBox"..i)
					DUF_Settings[DUF_INDEX][unit].TextBox[i].attach = "Unit Frame"
				end
			end
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.3"] then -- Removing Voice Icon as an attach
		for k,v in pairs(DUF_FRAME_INDICES) do
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].furycolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].furycolor = { r=PowerBarColor[17].r, g=PowerBarColor[17].g, b=PowerBarColor[17].b }
			end
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.4"] then -- Updates to DK rune cooldowns
		local settings = DUF_Settings[DUF_INDEX].player.DEATHKNIGHT
		settings.cooldownfont="Fonts/ARIALN.TTF"
		settings.cooldownfontsize=10
		settings.cooldownfonthide=true -- Don't show by default because they weren't there before.
		for k,v in pairs(DUF_FRAME_INDICES) do
			if not DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].holycolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[NS.Bar.Power].holycolor = { r=PowerBarColor[9].r, g=PowerBarColor[9].g, b=PowerBarColor[9].b }
			end
		end
	end
	
	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.5"] then -- Adding back pet happiness
		if not DUF_Settings[DUF_INDEX].pet.HappinessIcon and not DUF_Settings[DUF_INDEX].pet.HappinessIcon.backgroundstyle then
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.backgroundstyle = 2
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.bgalpha = 1
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.bgcolor.a = nil
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.bgpadding = 5
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.attach = "Unit Frame"
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.attachpoint = "TOPLEFT"
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.attachto = "TOPLEFT"
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.mouseovercolor = { r=1, g=1, b=0 }
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.leftclick = 1
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.rightclick = 3
			DUF_Settings[DUF_INDEX].pet.HappinessIcon.middleclick = 2
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED9.0"] then
		if DUF_Settings[DUF_INDEX].PetBattleHidePlayer then
			DUF_Settings[DUF_INDEX].petbattlehideplayer = DUF_Settings[DUF_INDEX].PetBattleHidePlayer
			DUF_Settings[DUF_INDEX].PetBattleHidePlayer = nil
		end
		if DUF_Settings[DUF_INDEX].PetBattleHide then
			DUF_Settings[DUF_INDEX].petbattlehide = DUF_Settings[DUF_INDEX].PetBattleHide
			DUF_Settings[DUF_INDEX].PetBattleHide = nil
		end
		if DUF_Settings[DUF_INDEX].PetBattleHideParty then
			DUF_Settings[DUF_INDEX].petbattlehideparty = DUF_Settings[DUF_INDEX].PetBattleHideParty
			DUF_Settings[DUF_INDEX].PetBattleHideParty = nil
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED9.1"] then -- Adding RankIcons and player Honor bar
		for i=1, #DUF_FRAME_INDICES do
			if not DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].RankIcon then
				DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].RankIcon = {}
				DL_Copy_Table(DUF_DEFAULT_SETTINGS[DUF_FRAME_INDICES[i]].RoleIcon, DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].RankIcon)
			end
		end
		for i=1, #DUF_FRAME_INDICES do
			if DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].manacolor then
				DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].color = {}
				DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].manacolor, DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].color)
				if not DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].color2 then
					DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].color2 = {}
					DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].color, DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].color2)
				end
				DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].ragecolor = nil
				DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].manacolor = nil
				DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].focuscolor = nil
				DUF_Settings[DUF_INDEX][DUF_FRAME_INDICES[i]].StatusBar[NS.Bar.Cast].energycolor = nil
			end
		end
		if not DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor] then
			DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor] = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Cast], DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor])
			DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].yoffset = DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].yoffset - 20 -- dodgy slightly different position because lazy
		end
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED10.0"] then -- Adding Evoker class colour and bar data
		if EssencePlayerFrame then
	---- EVOKER
			DUF_Settings[DUF_INDEX].classcolorEvoker = {
				["r"] = 0.2000000178813934,
				["g"] = 0.5764706134796143,
				["b"] = 0.4980392456054688,
			}
			DUF_Settings[DUF_INDEX].player.EVOKER = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX].player.DEATHKNIGHT, DUF_Settings[DUF_INDEX].player.EVOKER)
			settings = DUF_Settings[DUF_INDEX].player.EVOKER
			settings.width = 25
			settings.height = 25
			settings.sizelock = true
			settings.cooldownspeccolors = nil
--			settings.numtextures = 0
--			if settings.vertical then
--				settings.direction = 4
--			else
				settings.direction = 1
--			end
			settings.vertical = nil
			settings.borders = {} -- element border
			settings.textures = {} -- element
--			if DUF_CLASS_CENTERS[settings.attachto] then
--				settings.centeralign = true
--			end
			settings.size = nil
			settings.customtexture = nil
		end
	end
	if not DUF_Settings[DUF_INDEX]["INITIALIZED11.0"] then -- FontString SetJustfyV require "MIDDLE" instead of "CENTER"
		local function UpdateSettings(table)
			for k, v in pairs(table) do
				if type(v) == "table" then
					UpdateSettings(v)
				else
					if k == "justifyV" and v == "CENTER" then
						table[k] = "MIDDLE"
					end
				end
			end
		end
		UpdateSettings(DUF_Settings[DUF_INDEX])
	end
	
-- *** Copy the latest init. setting to the function at the bottom ***
	DUF_Settings[DUF_INDEX]["INITIALIZED11.0"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED10.0"] = true -- requires EssencePlayerFrame???
	DUF_Settings[DUF_INDEX]["INITIALIZED9.1"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED9.0"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.5"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED7.4"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.3"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.2"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0c"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0b"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0a"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED6.1"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED6.0"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.11"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED5.10"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED5.9"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED5.8"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.7"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.6"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.5"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.4"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.3"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.2"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.1"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0c"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0b"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0a"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0"] = true	
	DUF_Settings[DUF_INDEX]["INITIALIZED4.18"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED4.17"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED4.1a"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED4.0a"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED4.0"] = true --Fizzlemizz Begins
	DUF_Settings[DUF_INDEX]["INITIALIZED3.1.0a"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED3.0.3a"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.4"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3x"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3w"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3u"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3t"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3s"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.2c"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.2"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.1"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.0f"] = true
	DUF_Settings[DUF_INDEX]["INITIALIZED2.0"] = true
end

function NS:DUF_Initialize_NewSettings()
	if DUF_Settings[DUF_INDEX]["INITIALIZED11.0"] then return end
	Update_All_NewSettings()
end
